#define NUMNODES        50   /*  Total de ns                      */
#define MAX             50   /*  Mximo de expanses e transies  */
#define MAXLISTS        50   /*  Mximo de listas de trajetrias   */
#define TRUE		 1
#define FALSE		 0
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>

/********************************************************************

 
  Programa blarg.cpp (busca em largura)
  =====================================

  Executa busca para encontrar trajetria de um noh de origem
  at um noh de destino, totalizando a distncia percorrida
  caso encontre alguma soluo.

  Como a busca  em largura, a menor trajetria, se existir,
   encontrada.

  Usa listas encadeadas, simuladas por arrays, com ponteiros inteiros

  
********************************************************************/


/*********************
  Smbolos globais:
**********************/

struct dataarea {                  // Informaes sobre um arco
	char origem[20+1];
	char destino[20+1];
	int ativo;
	int medida;
	} ;

struct dataarea transicao[MAX];    // Array de transies = arcos

struct dataarea expansoes[MAX];    // Array de expanses = arcos

struct nodetype {                  // N:
	struct dataarea info;      // Informaes sobre arco
	int next;                  // Prximo n
	};

struct nodetype node[NUMNODES];    // Caixa de ns
                                   // = listas encadeadas de
                                   // trajetrias

struct list {                      // Ponteiros p/ listas em node[]
	int front;                 // Incio da trajetria
	int rear;                  // Final da trajetria
	int lenght;                // Comprimento da trajetria
	};

/* struct list trajetorias[MAXLISTS];  estrutura do programa original
                                       - nao usada */

struct list lista[MAXLISTS];       // Ponteiros p/ listas em node[]
                                   // (trajetrias)

struct nodetype_f {                // N da fila:
	struct list list_header;   // Lista de trajetrias
	int next;                  // Prximo n
	};

struct nodetype_f node_f[NUMNODES];// Caixa de ns node_f
                                   // = fila de trajetrias

struct fila {                      // Ponteiros para incio
        int frente;                // e fim da fila em node_f
        int tras;
	};

struct fila f;                     // f= fila

char origem[20], destino[20];      // Strings para receber
                                   // informao teclada

FILE *pf;                          // Arquivo de arcos

int overflow,                      // Indicadoe de overflow
    underflow,                     // Indicador de underflow
    avail,                         // Ponteiro para prximo n
                                   // disponvel em node[]

    avail_f,                       // Ponteiro para prximo n
                                   // disponvel em node_f[]

    n_listas,                      // Nmero de listas

    n_expansoes;                   // Nmero de arcos partindo de
                                   // no_corrente
                                   // (elementos de expansoes[])

char *no_corrente;                 // N corrente

int n_trajetorias,                 // Total de arcos possveis
    trajet;                        // ndice do array de transies

int meta_alcancada;                // Flag que indica
                                   // se a meta foi alcanada


/************************* Funes *********************************/

/**************** Funes que manipulam a fila *********************/

int empty_f(struct fila *);
void push_f(struct fila *,struct list *, int *);
void create_avail_f(void);
int getnode_f(void);
void freenode_f(int);

/********* Funes que manipulam as listas de trajetrias **********/

void imprimir_lista_ei(struct list *);
void imprimir_dado(struct dataarea *);
void create_avail_ei(void);
int getnode_ei(void);
void push_lei(struct list *,struct dataarea *,int *);
void place_ei(struct list *, struct dataarea *, int *);
void insafter_ei(struct list *,int, struct dataarea *, int *);

/****************** Outras funes usadas na busca *****************/

int expandir_no(char *, struct dataarea[]);
void criar_novas_trajetorias(struct list *,struct dataarea[],
			     struct list[]);
int atinge_a_meta(struct list *, char *);
void anexar(struct list[]);
void obter_trajetoria_corrente(struct fila *,struct list *, int *);
int copia_no(int, int *, int *, int *);


/********************************************************************

  Mdulo principal - main()
  =========================


  Finalidade: Abre e l arquivo de arcos, recebe origem e destino
              escolhidos pelo usurio, executa busca e imprime
              resultado.


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  currarea             : dataarea  : informao sobre um arco.
                                     Usada s na leitura do
                                     arquivo de dados
  trajetoria_corrente  : list      : ponteiros p/ trajetria
                                     sendo testada
  k                    : inteiro   : contador


  Smbolos globais     :  tipo     : descrio
  utilizados
  -------------------------------------------------------------------

  pf                   :  FILE     : arquivo de arcos
  meta_alcancada       :  inteiro  : flag que indica se a meta foi
                                     alcanada
  f                    :  fila     : ponteiros para incio e fim
                                     da fila em node_f
  overflow             :  inteiro  : indicador de overflow
  underflow            :  inteiro  : indicador de underflow
  n_trajetorias        :  inteiro  : total de arcos possveis
  n_listas             :  inteiro  : nmero de listas
  lista                :  list     : ponteiros para listas em node[]
  transicao            :  dataarea : array de transies = arcos
  origem               :  string   : string p/ receber informao
                                     teclada
  destino              :  string   : string p/ receber informao
                                     teclada
  no_corrente          :  string   : n corrente
  expansoes            :  dataarea : array de expanses (arcos)
  n_expansoes          :  inteiro  : nmero de arcos partindo
                                     de no_corrente
  node                 :  nodetype : caixa de ns
                                     = listas de trajetrias


  Funes chamadas:
  -------------------------------------------------------------------
  create_avail_ei()
  create_avail_f()
  expandir_no()
  criar_novas_trajetorias()
  anexar()
  obter_trajetoria_corrente()
  atinge_a_meta()
  imprimir_lista_ei()

********************************************************************/

void main()
{
struct dataarea currarea;
struct list trajetoria_corrente;
int  k;                           // i no  usado

// pf=fopen("arq9507.dat","r");            // abre arquivo de arcos
pf=fopen("arqbus1.txt","r");
//clrscr();

meta_alcancada = FALSE;

trajetoria_corrente.front = -1;         // trajetria corrente
trajetoria_corrente.rear = -1;          // est vazia
trajetoria_corrente.lenght = 0;

create_avail_ei();                      // inicializa caixa de ns
                                        // node

create_avail_f();                       // inicializa caixa de ns
                                        // node_f (fila)

f.frente = -1;                          // aterra ponteiros
f.tras   = -1;                          // para incio e fim da fila

overflow  = FALSE;
underflow = FALSE;
n_trajetorias = 0;
n_listas = 0;

for (k=0;k<MAXLISTS;k++)                // inicializa lista
   lista[k].front = lista[k].rear = -1; // de trajetrias

// Preenche currarea com dados lidos do arquivo de arcos.
// Preenche array transiao[] com dados dos arcos,
// marcando cada elemento como nao ativo.
// Guarda quantidade total de arcos em n_trajetrias.

while (fscanf(pf,"%s%s%d\n",&(currarea.origem),&(currarea.destino),
	      &(currarea.medida)) != EOF){

  currarea.origem[20] = 0 ;
  currarea.destino[20] = 0;

  strcpy(transicao[n_trajetorias].origem,currarea.origem);
  strcpy(transicao[n_trajetorias].destino,currarea.destino);
  transicao[n_trajetorias].medida = currarea.medida;
  transicao[n_trajetorias].ativo = FALSE;
  n_trajetorias++;

 }
 fclose(pf);                                    // Fecha arq. de arcos

 printf("Qual o noh de origem desejado ?");  // Origem e destino
 gets(origem);                                  // escolhidos pelo
 printf("Qual o noh de destino ?");          // usurio
 gets(destino);
// clrscr();
 printf("\t\t\tBusca em Largura\n\n");

 printf("\tOrigem: %s\tDestino: %s\n",origem,destino);

 // Preenche array expansoes[] com todos os arcos que
 // partem da origem.
 
 no_corrente = origem;
 expandir_no(no_corrente, expansoes);  

 // Enquanto houver arcos partindo do n corrente
 // (i.e. enquanto o primeiro elemento de expansoes[] for <> 0)
 // ---  OU  ---
 // enquanto houver trajetrias na fila (i.e. frente > -1)
 // executar o seguinte loop:

 while (expansoes[0].medida != 0 || f.frente > -1) {

 // Se ainda houver arcos partindo do n corrente,
 // cria novas trajetrias em lista[] e as coloca na fila

  if (expansoes[0].medida != 0) {
   criar_novas_trajetorias(&trajetoria_corrente,expansoes,lista);
   anexar(lista);
   n_listas += n_expansoes;
   }

   // retira da fila a prxima trajetria a ser testada

   obter_trajetoria_corrente(&f,&trajetoria_corrente,&underflow);

   // se atinge a meta, seta flag e pra

   if (atinge_a_meta(&trajetoria_corrente,destino)) {
       meta_alcancada = TRUE;
       break;
       }

   // seno, expande o filho do n corrente e continua

     else
       no_corrente = node[trajetoria_corrente.rear].info.destino;

   expandir_no(no_corrente,expansoes);
 }
 // fim do WHILE

 // imprime resultado e termina

 imprimir_lista_ei(&trajetoria_corrente);
 getch();

}

/********************************************************************

  Funo imprimir_lista_ei()
  ==========================


  Finalidade: Imprime soluo encontrada, com a distncia total,
              ou mensagem dizendo que no h soluo.


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  pp                   : list      : trajetria encontrada


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  i                    : inteiro   : ponteiro
  dist_total           : inteiro   : distncia total percorrida


  Smbolos globais     :  tipo     : descrio
  utilizados
  -------------------------------------------------------------------
  node                 :  nodetype : caixa de ns
                                     = listas de trajetrias

  meta_alcancada       :  inteiro  : flag que indica se a meta foi
                                     alcanada


  Funes chamadas:
  -------------------------------------------------------------------
  imprimir_dado()

********************************************************************/

void imprimir_lista_ei(struct list *pp)
 {
 int i, dist_total;

 dist_total = 0;

 if (!meta_alcancada) {
    printf("\n\n*** Nao foi encontrada nenhuma soluao\n");
    }
   else {
    printf("\n\t\tTrajetria encontrada\n\n");
    i = pp->front;
    while (i != -1) {
      imprimir_dado(&(node[i].info));
      dist_total += node[i].info.medida;
      i = node[i].next;
     }  /*  end while  */
     printf("\tDistancia total do trajeto = %d\n",dist_total);
    }
}  /* end imprimir_lista  */


/********************************************************************

  Funo imprimir_dado()
  ======================


  Finalidade: Imprime dados de um arco


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  pa                   : dataarea  : dados de um arco

*********************************************************************/

void imprimir_dado(struct dataarea *pa)
{
 printf("origem: %-20.20s\tdestino: %-20.20s\tmedida: %d\n",
		  pa->origem,pa->destino,pa->medida);
}


/********************************************************************

  Funo create_avail_ei()
  ========================


  Finalidade: Inicializa caixa de ns node


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  i                    : inteiro   : contador


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  node                 : nodetype  : caixa de ns
                                     = listas de trajetrias

*********************************************************************/

void create_avail_ei(void)
{
int i;

avail = 0;
for (i = 0; i < NUMNODES-1; i++)
     node[i].next = i+1;

node[NUMNODES-1].next = -1;
return;
}   /*  end create_avail_ei   */


/********************************************************************

  Funo getnode_ei()
  ===================


  Finalidade: Retorna ponteiro inteiro para um novo n,
              se ainda existir. Seno, retorna o valor -1


  Valor retornado      : tipo      : descrio
  -------------------------------------------------------------------
  p                    : inteiro   : ponteiro para n livre


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  p                    : inteiro   : ponteiro


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  node                 : nodetype  : caixa de ns
                                     = listas de trajetrias
  avail                : inteiro   : ponteiro para prximo n
                                     disponvel em node[]

********************************************************************/

int getnode_ei(void)
{
int p;
if (avail == -1) {                    // se nao existir (avail == -1)
   return(avail);                     // retorna -1
    }
p = avail;
avail = node[avail].next;
return(p);
}  /*  end getnode_ei  */


/********************************************************************

  Funo insafter_ei()
  ====================


  Finalidade: Insere uma nova trajetria no final da lista


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  pl                   : list      : lista de trajetrias
  p                    : int       : ponteiro p/ fim da lista
  px                   : dataarea  : rea com dados do arco
  poverflow            : int       : indicador de overflow de node[]


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  q                    : int       : ponteiro p/ n alocado em node[]


  Smbolos globais     :  tipo     : descrio
  utilizados
  -------------------------------------------------------------------
  node                 :  nodetype : caixa de ns
                                     = listas de trajetrias


  Funes chamadas:
  -------------------------------------------------------------------
  getnode_ei()

********************************************************************/

void insafter_ei (struct list *pl,int p, struct dataarea *px,
                  int *poverflow)
{
int q;
if (p == -1) {
    printf("insero vazia\n");
    return;
    }

q = getnode_ei();
if (q == -1) {
    *poverflow = TRUE;
    return;
    }
*poverflow = FALSE;
node[q].info = *px;
node[q].next = node[p].next;
node[p].next = q;
pl->rear = q;
return;
}  /*  end insafter_ei   */


/********************************************************************

  Funo place_ei()
  =================


  Finalidade: Coloca uma nova trajetria na lista


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  pl                   : list      : lista de trajetrias
  pa                   : dataarea  : rea com dados do arco
  poverflow            : int       : indicador de overflow de node[]


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  q                    : int       : ponteiro p/ fim da lista


  Smbolos globais     :  tipo     : descrio
  utilizados
  -------------------------------------------------------------------
  node                 :  nodetype : caixa de ns
                                     = listas de trajetrias


  Funes chamadas:
  -------------------------------------------------------------------
  push_lei()
  insafter_ei()

********************************************************************/

void place_ei(struct list *pl,struct dataarea *pa, int *poverflow)
{
int /* p, */ q;     // p no  usado

q = pl->rear;
if (q == -1)     /* a lista estava vazia: novo n ser o primeiro */
    push_lei(pl,pa,poverflow);
  else          /* inclusao no fim da lista  */
    insafter_ei(pl,q,pa,poverflow);
pl->lenght++;
}   /*  end place_ei  */


/********************************************************************

  Funo push_lei()
  =================


  Finalidade: Coloca trajetria como primeira da lista


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  pl                   : list      : lista de trajetrias
  pa                   : dataarea  : rea com dados do arco
  poverflow            : int       : indicador de overflow de node[]


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  p                    : int       : ponteiro p/ n alocado em node[]


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  node                 : nodetype  : caixa de ns
                                     = listas de trajetrias


  Funes chamadas:
  -------------------------------------------------------------------
  getnode_ei()

********************************************************************/

void push_lei(struct list *pl,struct dataarea *pa,int *poverflow)
{
int p;

p = getnode_ei();

     /**** teste de overflow              ****/
if (p == -1) {
   *poverflow = TRUE;
   return;
   }

  else {
   *poverflow = FALSE;
   node[p].info = *pa;
   node[p].next = pl->front;
   pl->front = p;
   pl->rear = p;
   return;
	}
}  /* end push_lei  */


/********************************************************************

  Funo expandir_no()
  ====================


  Finalidade: Preenche array expansoes[] com todos os arcos que partem
              de no_corrente


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  no_corrente          : char      : n corrente
  expansoes[]          : dataarea  : array de arcos


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  j                    : int       : contador


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  MAX                  : #define   : mximo de expanses
  trajet               : int       : ndice de transicoes[]
  n_trajetorias        : int       : total de arcos possveis
  transicao[]          : dataarea  : array de transies
  n_expansoes          : int       : nmero de arcos partindo
                                     de no_corrente

********************************************************************/

int expandir_no(char *no_corrente, struct dataarea expansoes[])
{
 int j;

 for (j = 0;j < MAX;j++)            // zera array de expanses
      expansoes[j].medida = 0;

 j = 0;                             // ndice de expansoes[]
 trajet = 0;                        // ndice de transicao[]

 while(trajet < n_trajetorias)      // varre array de arcos
  {
   // se origem deste arco for igual  origem teclada
   // e esta trajetria NAO estiver ativa (marcada),
   // marca esta trajetria para evitar ciclos
   // e copia este arco para array expansoes

   if(!strcmp(transicao[trajet].origem,no_corrente)    
	     && !transicao[trajet].ativo)              
    {
     transicao[trajet].ativo = TRUE;	                                    
     memcpy(&expansoes[j++], &transicao[trajet], 
                             sizeof(struct dataarea));
    }
   trajet++;
  }
  n_expansoes = j;                  // nmero de arcos encontrados 
 return 0;                          // saindo de origem
}


/********************************************************************

  Funo criar_novas_trajetorias()
  ================================


  Finalidade: cria novas listas de trajetrias em node[], 
              apontadas por lista[]


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  trajetoria_corrente  : list      : ponteiros p/ trajetria
                                     sendo testada.
  expansoes[]          : dataarea  : array de arcos
  lista[]              : list      : array de ponteiros p/ listas
                                     em node[]


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  i                    : int       : contador
  cont                 : int       : ponteiro usado pela funo
                                     copia_no()
  q                    : int       : ponteiro p/ incio da lista
  inicio               : int       : ponteiro
  fim                  : int       : ponteiro


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  n_expansoes          : int       : nmero de arcos partindo
                                     de no_corrente
  overflow             : int       : indicador de overflow


  Funes chamadas:
  -------------------------------------------------------------------
  copia_no()
  place_ei()

********************************************************************/

void criar_novas_trajetorias(struct list *trajetoria_corrente,
			     struct dataarea expansoes[],
			     struct list lista[])
{
int i, cont, q, inicio, fim;

// Para cada arco que comea na mesma origem,
// que est em expansoes[], monta lista encadeada em node[]

for (i = 0;i < n_expansoes; i++)  {     
  q = trajetoria_corrente->front;
  cont = 0;
  inicio = copia_no(q,&cont,&inicio,&fim); 
  if (inicio == -1)
      fim = -1;
  lista[n_listas + i].lenght = trajetoria_corrente->lenght;
  lista[n_listas + i].front = inicio;
  lista[n_listas + i].rear = fim;
  place_ei(&lista[n_listas + i],&expansoes[i],&overflow);
  if (overflow) { /* Mensagem de erro de overflow */
     }
  }
}


/********************************************************************

  Funo atinge_a_meta()
  ======================


  Finalidade: verifica se o fim da trajetria corrente atinge 
              a meta. Se atingir, retorna TRUE; 
              seno, retorna FALSE.


  Valor retornado      : tipo      : descrio
  -------------------------------------------------------------------
  TRUE / FALSE         : int       : meta foi atingida?


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  trajetoria_corrente  : list      : ponteiros p/ trajetria
                                     sendo testada.
  destino              : char      : destino entrado pelo usurio


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  node                 :  nodetype : caixa de ns
                                     = listas de trajetrias

********************************************************************/

int atinge_a_meta(struct list *trajetoria_corrente, char *destino)
{
 if (strcmp(node[trajetoria_corrente->rear].info.destino,destino)==0)
     return (TRUE);
   else
    return (FALSE);
}


/********************************************************************

  Funo obter_trajetoria_corrente()
  ==================================


  Finalidade: Retira da fila a prxima trajetria a ser testada.


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  ps                   : fila      : fila
  pa                   : list      : ponteiros p/ trajetria retirada
  punderflow           : int       : indicador de underflow


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  i                    : int       : ponteiro temporrio


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  node_f               : nodetype  : caixa de ns da fila


  Funes chamadas:
  -------------------------------------------------------------------
  empty_f()
  freenode_f()

********************************************************************/

void obter_trajetoria_corrente(struct fila *ps,struct list *pa,
			      int *punderflow)
 {
 int i;
 if (empty_f(ps)) {
    *punderflow = TRUE;
    return;
    }

  *punderflow = FALSE;
  *pa = node_f[ps->frente].list_header;
  i = ps->frente;
  ps->frente = node_f[ps->frente].next;
  freenode_f(i);
  if (ps->frente == -1)
     ps->tras = -1;

 return;
 }  /* end obter_trajetoria_corrente  */


/********************************************************************

  Funo anexar()
  ===============


  Finalidade: Coloca trajetrias na fila


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  lista                : list      : lista de trajetrias


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  i                    : int       : contador


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  n_expansoes          : int       : nmero de arcos partindo
                                     de no_corrente
  f                    : fila      : fila
  n_listas             : int       : nmero de listas
  overflow             : int       : indicador de overflow


  Funes chamadas:
  -------------------------------------------------------------------
  push_f()

********************************************************************/

void anexar(struct list lista[])
{
int i;
for (i = 0;i < n_expansoes;i++)
    push_f(&f,&lista[n_listas + i], &overflow);
}


/********************************************************************

  Funo empty_f()
  ================


  Finalidade: Verifica se a fila est vazia


  Valor retornado      : tipo      : descrio
  -------------------------------------------------------------------
  TRUE / FALSE         : int       : fila est vazia?


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  ps                   : fila      : fila

********************************************************************/

int empty_f(struct fila *ps)
 {
 return((ps->frente == -1) ? TRUE : FALSE);
 }  /*  end empty_f  */


/********************************************************************

  Funo push_f()
  ===============


  Finalidade: Coloca uma trajetria na fila


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  ps                   : fila      : fila
  pa                   : list      : uma trajetria 
                                     (elemento de lista[])
  overflow             : int       : indicador de overflow


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  p                    : int       : ponteiro


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  node_f               : nodetype_f: caixa de ns da fila


  Funes chamadas:
  -------------------------------------------------------------------
  getnode_f()

********************************************************************/

void push_f(struct fila *ps,struct list *pa,int *poverflow)
{
int p;

p = getnode_f();

     /**** teste de overflow              ****/
if (p == -1) {
   *poverflow = TRUE;
   return;
   }

  else {
   *poverflow = FALSE;
   node_f[p].list_header = *pa;
   node_f[p].next = -1;
   if (ps->tras > -1)
      node_f[ps->tras].next = p;
   else
      ps->frente = p;
   ps->tras = p;

   return;
	}
}  /* end push_f  */


/********************************************************************

  Funo create_avail_f()
  =======================


  Finalidade: Inicializar caixa de ns node_f[] (fila)


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  i                    : int       : contador


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  NUMNODES             : #define   : total de ns
  node_f               : nodetype_f: caixa de ns da fila

********************************************************************/

void create_avail_f(void)
{
int i;

avail_f = 0;
for (i = 0; i < NUMNODES-1; i++)
     node_f[i].next = i+1;

node_f[NUMNODES-1].next = -1;
return;
}   /*  end create_avail_f   */


/********************************************************************

  Funo getnode_f()
  ==================


  Finalidade: Retorna ponteiro inteiro para um novo n para a fila,
              se ainda existir. Seno, retorna o valor -1


  Valor retornado      : tipo      : descrio
  -------------------------------------------------------------------
  p                    : inteiro   : ponteiro para n livre


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  p                    : int       : ponteiro


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  avail_f              : int       : ponteiro p/ prximo n 
                                     disponvel em node_f[]
  node_f               : nodetype_f: caixa de ns da fila

********************************************************************/

int getnode_f(void)
{
int p;
if (avail_f == -1) {
   return(avail_f);
    }
p = avail_f;
avail_f = node_f[avail_f].next;
return(p);
}  /*  end getnode_f  */


/********************************************************************

  Funo freenode_f()
  ===================


  Finalidade: Liberar n da fila


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  p                    : int       : ponteiro para n a liberar


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  avail_f              : int       : ponteiro p/ prximo n 
                                     disponvel em node_f[]
  node_f               : nodetype_f: caixa de ns da fila

********************************************************************/

void freenode_f(int p)
{
node_f[p].next = avail_f;
avail_f = p;
return;
} /*  end freenode_f  */


/********************************************************************

  Funo copia_no()
  ====================


  Finalidade: Monta lista encadeada em node[]


  Valor retornado      : tipo      : descrio
  -------------------------------------------------------------------
  p                    : inteiro   : ponteiro para ltimo n 
                                     adicionado  lista


  Parmetros           : tipo      : descrio
  -------------------------------------------------------------------
  no                   : int       : n da lista
  cont                 : int       : se = 0,  primeira execuo
                                     desta funo.
                                     se <> 0, ponteiro para ltimo
                                     n da lista
  inicio               : int       : inicio da lista
  fim                  : int       : fim da lista


  Smbolos locais      : tipo      : descrio
  -------------------------------------------------------------------
  p                    : int       : ponteiro


  Smbolos globais     : tipo      : descrio
  utilizados
  -------------------------------------------------------------------
  node                 :  nodetype : caixa de ns
                                     = listas de trajetrias


  Funes chamadas:
  -------------------------------------------------------------------
  getnode_ei()
  copia_no() - recursiva

********************************************************************/

int copia_no(int no, int *cont, int *inicio, int *fim)
{
int p;

if (no == -1)                 // se no estiver aterrado,
   return (no);               // retorna -1

p = getnode_ei();             // aloca novo n p

if (*cont == 0)               // se for 1a execuo de copia_no,
   *inicio = p;               // atribui inicio
*cont = p;
                              
node[p].info = node[no].info; // preenche node[p] c/ informaao de no
                              
// monta lista encadeada em node[],
// atravs de chamadas recursivas

node[p].next = copia_no(node[no].next,cont,inicio,fim);
*fim = *cont;
return (p);
}
